// Copyright 2018 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#ifndef TYPES_DYNAMIC_PUB_SUB_TYPE_H
#define TYPES_DYNAMIC_PUB_SUB_TYPE_H

#include <fastrtps/types/TypesBase.h>
#include <fastrtps/TopicDataType.h>
#include <fastrtps/types/DynamicTypePtr.h>
#include <fastrtps/types/DynamicDataPtr.h>

namespace eprosima {
namespace fastrtps {
namespace types {

class DynamicPubSubType : public eprosima::fastrtps::TopicDataType
{
public:

    RTPS_DllAPI DynamicPubSubType();
    RTPS_DllAPI DynamicPubSubType(DynamicType_ptr pDynamicType);
    RTPS_DllAPI virtual ~DynamicPubSubType();

    RTPS_DllAPI void* createData();
    RTPS_DllAPI void deleteData(void * data);
    RTPS_DllAPI bool deserialize(eprosima::fastrtps::rtps::SerializedPayload_t *payload, void *data);
    RTPS_DllAPI bool getKey(void *data, eprosima::fastrtps::rtps::InstanceHandle_t *ihandle, bool force_md5=false);
    RTPS_DllAPI std::function<uint32_t()> getSerializedSizeProvider(void* data);
    RTPS_DllAPI bool serialize(void *data, eprosima::fastrtps::rtps::SerializedPayload_t *payload);

    RTPS_DllAPI void CleanDynamicType();
    RTPS_DllAPI DynamicType_ptr GetDynamicType() const;
    RTPS_DllAPI ResponseCode SetDynamicType(DynamicData_ptr pData);
    RTPS_DllAPI ResponseCode SetDynamicType(DynamicType_ptr pType);

protected:

    void UpdateDynamicTypeInfo();

    DynamicType_ptr mDynamicType;
    MD5 m_md5;
    unsigned char* m_keyBuffer;
};

} // namespace types
} // namespace fastrtps
} // namespace eprosima

#endif // TYPES_DYNAMIC_PUB_SUB_TYPE_H
